﻿---
title: Home
---

# `bottom`

A customizable cross-platform graphical process/system monitor for the terminal, supporting Linux, macOS, and Windows. Inspired by other tools like [gtop](https://github.com/aksakalli/gtop), [gotop](https://github.com/xxxserxxx/gotop), and [htop](https://github.com/htop-dev/htop).

---

This site serves as extended documentation for bottom alongside the [`README.md`](https://github.com/ClementTsang/bottom#readme).

!!! Warning

    Some areas of this site are still in progress and may be missing details.  Feel free to suggest/contribute changes!

## Installation

!!! Tip

    It is a good idea to first check out the [Support](./support/official) page to see if your system is officially supported!

!!! Tip

    If you're facing some issues during/after installation, check out the [Troubleshooting](./troubleshooting) page for some common problems and solutions.

To install bottom, refer to [the installation section of the `README.md`](https://github.com/ClementTsang/bottom#installation),
which contains a list of all the installation methods.

## Usage and configuration

You can refer to the [usage](./usage/general-usage/) pages on how to use bottom (e.g. keybinds, some features, a general overview of what each widget does).

To configure bottom, refer to the [configuration](./configuration/command-line-flags/) pages (e.g. how it behaves, how it looks).

## Contribution

New contributors are always welcome! See the [contribution](./contribution/issues-and-pull-requests/) section for how to contribute to
bottom, whether it be filing issues, writing documentation, creating pull requests, etc.
